# SPDX-FileCopyrightText: 2024 Detlef Gebhardt, written for CircuitPython
# SPDX-FileCopyrightText: Copyright (c) 2024 Detlef Gebhardt
# SPDX-FileCopyrightText: based on a PicoBoy template in Micropython
#
# SPDX-License-Identifier: GEBMEDIA
import board
import busio
import time
from adafruit_bus_device.i2c_device import I2CDevice

class STK8BA58:
    def __init__(self): 
        global device, DEV_ADDR, sda, scl, XOUT1, YOUT1, ZOUT1
        DEV_ADDR = 0x18    # STK8BA58
        sda=board.GP20
        scl=board.GP21 
        XOUT1  = 0x02
        YOUT1  = 0x04
        ZOUT1  = 0x06
        i2c = busio.I2C(scl=scl, sda=sda, frequency = 400000)
        device = I2CDevice(i2c, DEV_ADDR)
        while not i2c.try_lock():
            pass
            
    def xAcc(self):
        device.write(bytes([XOUT1]))
        data = bytearray(2)
        device.readinto(data)
        value = int(data[0] / 16) + data[1] * 16 
        if value >= 2048:
            value = value-4096
        return value/1024
    
    def yAcc(self):
        device.write(bytes([YOUT1]))
        data = bytearray(2)
        device.readinto(data)
        value = int(data[0] / 16) + data[1] * 16 
        if value >= 2048:
            value = value-4096
        return value/1024

    def zAcc(self):
        device.write(bytes([ZOUT1]))
        data = bytearray(2)
        device.readinto(data)
        value = int(data[0] / 16) + data[1] * 16 
        if value >= 2048:
            value = value-4096
        return value/1024

if __name__=='__main__':
    #do nothing
    pass